Skip to content

Get user information in batches

This document is automatically generated based on https://github.com/authing/authing-docs-factory based on https://api-explorer.genauth.ai V3 API, and is consistent with API parameters and return results. If this document description is incorrect, please refer to V3 API.

Get user information in batches through the user ID list. You can choose to obtain custom data, identities, select a specified user ID type, etc.

Method name

ManagementClient.getUserBatch

Request parameters

| Name | Type | Required | Default value | Description | Sample value | | ----------------- | -------- | -------------------------------------- | ------------------------------------ | ---------------------------- ... | ["6229ffaxxxxxxxxcade3e3d9","6229ffaxxxxxxxxcade3e3d0"] | | userIdType | string | No | user_id | User ID type, the default value is user_id, the optional values are:
- user_id: GenAuth user ID, such as 6319a1504f3xxxxf214dd5b7
- phone: User phone number
- email: User email
- username: User name
- external_id: User ID in the external system, corresponding to the externalId field of GenAuth user information
- identity: User's external identity source information, in the format of <extIdpId>:<userIdInIdp>, where <extIdpId> is the ID of the GenAuth identity source. ID, <userIdInIdp> is the ID of the user in the external identity source.
Example value: 62f20932716fbcc10d966ee5:ou_8bae746eac07cd2564654140d2a9ac61.
- sync_relation: The user's external identity source information, in the format of <provier>:<userIdInIdp>, where <provier> is the synchronization identity source type, such as wechatwork, lark; <userIdInIdp> is the ID of the user in the external identity source.
Example value: lark:ou_8bae746eac07cd2564654140d2a9ac61.
| user_id | | withCustomData | boolean | no | - | Whether to obtain custom data | true | | flatCustomData | boolean | no | - | Whether to flatten the extended field| | | withIdentities | boolean | no | - | Get identities | true | | withDepartmentIds | boolean | no | - | Get department ID list | true |

Sample code

ts
import { ManagementClient, Models } from "authing-node-sdk";

// Initialize ManagementClient
const managementClient = new ManagementClient({
  // Need to be replaced with your GenAuth Access Key ID
  accessKeyId: "GEN_AUTH_ACCESS_KEY_ID",
  // Need to be replaced with your GenAuth Access Key Secret
  accessKeySecret: "GEN_AUTH_ACCESS_KEY_SECRET",
  // If it is a private deployment customer, you need to set the GenAuth service domain name
  // host: 'https://api.your-authing-service.com'
});

(async () => {
  const result = await managementClient.getUserBatch({
    // Replace user ID array
    userIds: ["6229ffaxxxxxxxxcade3e3d9"],
    userIdType: "user_id",
    withCustomData: true,
    withIdentities: true,
    withDepartmentIds: true,
  });
  console.log(JSON.stringify(result, null, 2));
})();

Request response

Type: UserListRespDto

NameTypeDescription
statusCodenumberBusiness status code, which can be used to determine whether the operation is successful. 200 means success.
messagestringDescription
apiCodenumberSegmented error code, which can be used to get the specific error type (successful request does not return). For a detailed list of error codes, see: API Code List
requestIdstringRequest ID. Returned when the request fails.
dataarrayuser list

Sample result:

json
{
  "statusCode": 200,
  "message": "Operation successful",
  "requestId": "934108e5-9fbf-4d24-8da1-c330328abd6c",
  "data": {
    "userId": "6229ffaxxxxxxxxcade3e3d9",
    "createdAt": "2022-07-03T03:20:30.000Z",
    "updatedAt": "2022-07-03T03:20:30.000Z",
    "status": "Activated",
    "workStatus": "Active",
    "externalId": "10010",
    "email": "test@example.com",
    "phone": "188xxxx8888",
    "phoneCountryCode": "+86",
    "username": "bob",
    "name": "xxxx",
    "nickname": "xxxx",
    "photo": "https://files.authing.co/authing-console/default-user-avatar.png",
    "loginsCount": 3,
    "lastLogin": "2022-07-03T03:20:30.000Z",
    "lastIp": "127.0.0.1",
    "gender": "M",
    "emailVerified": true,
    "phoneVerified": true,
    "passwordLastSetAt": "2022-07-03T03:20:30.000Z",
    "birthdate": "2022-06-03",
    "country": "CN",
    "province": "BJ",
    "city": "BJ",
    "address": "xxxxxxx",
    "streetAddress": "Beijing Chaoyang District xxx Street",
    "postalCode": "438100",
    "company": "steamory",
    "browser": "Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0",
    "device": "iOS",
    "givenName": "xx",
    "familyName": "xx",
    "middleName": "James",
    "profile": "alice",
    "preferredUsername": "alice",
    "website": "https://my-website.com",
    "zoneinfo": "GMT-08:00",
    "locale": "af",
    "formatted": "132, My Street, Kingston, New York 12401.",
    "region": "Xinjiang Uyghur Autonomous Region",
    "userSourceType": "register",
    "passwordSecurityLevel": 1,
    "departmentIds": "[\"624d930c3xxxx5c08dd4986e\",\"624d93102xxxx012f33cd2fe\"]",
    "identities": {
      "identityId": "62299d8b866d2dab79a89dc4",
      "extIdpId": "6076bacxxxxxxxxd80d993b5",
      "provider": "wechat",
      "type": "openid",
      "userIdInIdp": "oj7Nq05R-RRaqak0_YlMLnnIwsvg",
      "accessToken": "57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx",
      "refreshToken": "57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx",
      "originConnIds": "[\"605492ac41xxxxe0362f0707\"]"
    },
    "identityNumber": "420421xxxxxxxx1234",
    "customData": {
      "school": "Peking University",
      "age": 22
    },
    "statusChangedAt": "2022-07-03T03:20:30.000Z"
  }
}

Data structure

UserDto

NameTypeIs it required?DescriptionSample value
userIdstringYesThe unique identifier of the user, which can be user ID, user name, email, phone number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id.6229ffaxxxxxxxxcade3e3d9
createdAtstringyescreation time2022-07-03T03:20:30.000Z
updatedAtstringyesupdate time2022-07-03T03:20:30.000Z
statusstringyescurrent status of the account:
- Activated: normal status
- Suspended: deactivated
- Deactivated: disabled
- Resigned: resigned
- Archived: archived
Suspended
workStatusstringyescurrent work status of the accountClosed
externalIdstringnothird-party external ID10010
emailstringnoemail address, case insensitivetest@example.com
phonestringNoPhone number without area code. If it is an international phone number, please specify the area code in the phoneCountryCode parameter.188xxxx8888
phoneCountryCodestringNoPhone area code. This parameter is optional for phone numbers in mainland China. The GenAuth SMS service does not yet support international phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes.+86
usernamestringNoUser name, unique in the user poolbob
namestringNoUser's real name, not uniquexxxx xxx
nicknamestringNoNicknamexxxx xxx
photostringnoAvatar linkhttps://files.authing.co/authing-console/default-user-avatar.png
loginsCountnumbernoTotal number of historical logins3
lastLoginstringnoLast login time2022-07-03T03:20:30.000Z
lastIpstringnoLast login IP127.0.0.1
genderstringyesGender:
- M: Male, male
- F: Female, female
- U: Unknown, unknown
M
emailVerifiedbooleanyesIs the email verified?true
phoneVerifiedbooleanyesIs the phone number verified?true
passwordLastSetAtstringNoUser's last password modification time2022-07-03T03:20:30.000Z
birthdatestringNoDate of birth2022-06-03
countrystringNoCountryCN
provincestringNoProvinceBJ
citystringNoCityBJ
addressstringNoAddressBeijing Chaoyang
streetAddressstringNoStreet addressBeijing Chaoyang District xxx Street
postalCodestringNoPostal code438100
companystringNoCompanysteamory
browserstringNoLast login browser UAMozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0
devicestringNoLast login deviceiOS
givenNamestringnofirst namexx
familyNamestringnolast namexx
middleNamestringnomiddle nameJames
profilestringnoPreferred Usernamealice
preferredUsernamestringnoPreferred Usernamealice
websitestringnoUser personal websitehttps://my-website.com
zoneinfostringnoUser time zone informationGMT-08:00
localestringnoLocaleaf
formattedstringnoFull standard address132, My Street, Kingston, New York 12401.
regionstringnoUser locationXinjiang Uyghur Autonomous Region
userSourceTypestringyesSource type:
- excel: Imported through excel
- register: User self-registration
- adminCreated: Manual creation by the administrator (including creating users using the management API)
- syncTask: Synchronization task of the synchronization center
excel
userSourceIdstringNoApplication ID or sync task ID
lastLoginAppstringNoApplication ID of the user's last login
mainDepartmentIdstringNoUser's main department ID
lastMfaTimestringNoThe time when the user last performed MFA authentication
passwordSecurityLevelnumberNoUser password security strength level1
resetPasswordOnNextLoginbooleanNoRequire password reset on next login
registerSourcearrayNoRegistration method
departmentIdsarrayNoUser department ID list["624d930c3xxxx5c08dd4986e","624d93102xxxx012f33cd2fe"]
identitiesarrayNoExternal identity source Nested type: <a IdentityDto.
identityNumberstringNoUser ID number420421xxxxxxxx1234
customDataobjectNoUser's extended field data{"school":"Peking University","age":22}
postIdListarrayNoUser-associated department ID
statusChangedAtstringNoUser status last modified time2022-07-03T03:20:30.000Z
tenantIdstringNoUser tenant ID

IdentityDto

NameTypeIs it requiredDescriptionExample value
identityIdstringyesIdentity source ID62299d8b866d2dab79a89dc4
extIdpIdstringyesIdentity source connection ID6076bacxxxxxxxxd80d993b5
providerstringyesExternal identity source type:
- wechat: WeChat
- qq: QQ
- wechatwork: WeChat for Enterprise
- dingtalk: DingTalk
- weibo: weibo
- github: GitHub
- alipay: Alipay
- baidu: Baidu
- lark: Feishu
- welink: Welink
- yidun: NetEase Yidun
- qingcloud: Qingyun
- google: Google
- gitlab: GitLab
- gitee: Gitee
- twitter: Twitter
- facebook: Facebook
- slack: Slack
- linkedin: Linkedin
- instagram: Instagram
- oidc: OIDC-type enterprise identity source
- oauth2: OAuth2-type enterprise identity source
- saml: SAML-type enterprise identity source
- ldap: LDAP-type enterprise identity source
- ad: AD-based enterprise identity source
- cas: CAS-based enterprise identity source
- azure-ad: Azure AD-based enterprise identity source
oidc
typestringyesIdentity type, such as unionid, openid, primaryopenid
userIdInIdpstringyesID in the external identity sourceoj7Nq05R-RRaqak0_YlMLnnIwsvg
userInfoInIdpobjectyesUser information in idp
accessTokenstringnoAccess Token in the external identity source (this parameter is only returned when the user actively obtains it, and the management side interface will not return it).57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx
refreshTokenstringnoRefresh Token in the external identity source (this parameter is only returned when the user actively obtains it, and the management side interface will not return it).57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx
originConnIdsarrayyesIdentity source connection ID list from which the identity comes["605492ac41xxxxe0362f0707"]

Agent infrastructure for identity, memory, and web action.